import sys
from types import ModuleType

from zope.configuration import xmlconfig
from zope.interface import implements

from lazr.restful.interfaces import IWebServiceConfiguration


def create_test_module(name, *contents):
    """Defines a new module and adds it to sys.modules."""
    new_module = ModuleType(name)
    sys.modules['lazr.restful.' + name] = new_module
    for object in contents:
        setattr(new_module, object.__name__, object)
    return new_module


def register_test_module(name, *contents):
    new_module = create_test_module(name, *contents)
    try:
        xmlconfig.string("""
            <configure
                xmlns:webservice=
                    "http://namespaces.canonical.com/webservice">
              <include package="lazr.restful" file="meta.zcml" />
              <webservice:register module="lazr.restful.%s" />
            </configure>
            """ % name)
    except Exception, e:
        del sys.modules['lazr.restful.' + name]
        raise e
    return new_module


class TestWebServiceConfiguration:
    implements(IWebServiceConfiguration)
    view_permission = "lazr.View"
    active_versions = ["beta", "1.0"]
    last_version_with_mutator_named_operations = "1.0"
    code_revision = "1.0b"
    default_batch_size = 50

    def get_request_user(self):
        return 'A user'
